#pragma once
#include "sra-api/sra_scene.h"
#include "ErrorAcelValue.h"

namespace google 
{
  namespace  protobuf
  { 
    class Message;
    class FieldDescriptor;
  }
}

using google::protobuf::Message;
using google::protobuf::FieldDescriptor;

using namespace sra;

class BAcel : public ErrorAcel
{
  Message* message;
  oid_t id;  // should be from the parent acel containing the message field

  /*class BValueAcel : ErrorAcelValue
  {
    string name;
    public:
      BValueAcel(string name) {}
      virtual float GetFloat();
      virtual int32_t GetInt();
      virtual string GetString();
      virtual bool GetBool();
      virtual float3_t GetFloat3();
      virtual byte_buffer_t GetByteBuffer();
      virtual float_buffer_t GetFloatBuffer();
      virtual int_buffer_t GetIntBuffer();
  };*/

  /**
   * BAcel::Property() needs to return IAcel-type of object. However, it is desirable to provide only interface for getting
   * value, because that's only data available in the case of acels predefined by pb::messages. The method BPropertyAcel::Value()
   * is provided only to mimick the same access as for XAcel.
   */
  class BPropertyAcel : 
    public ErrorAcel, 
    public ErrorAcelValue
  {  
    // const Message* message;
	Message* message;
    const FieldDescriptor* field;
  public:
    BPropertyAcel(Message* m, const FieldDescriptor*f );
    virtual IAcelValue* Value();

    // IAcelValue methods
    virtual float GetFloat();
    virtual void SetFloat(float val);

    virtual int32_t GetInt();
    virtual void SetInt(int32_t val);

    virtual string GetString();
    virtual void SetString(string val);

    virtual bool GetBool();
    virtual void SetBool(bool val);

    virtual float3_t GetFloat3();
    void SetFloat3(float3_t val);

    // Const access to the buffer inside, no copy created.
    virtual byte_buffer_t GetByteBuffer();
    // Makes a copy of the buffer parameter val
    virtual void SetByteBuffer(byte_buffer_t val);

    // Const access to the buffer inside, no copy created.
    virtual float_buffer_t GetFloatBuffer();
    // Makes a copy of the buffer parameter val
    virtual void SetFloatBuffer(float_buffer_t val);

    // Const access to the buffer inside, no copy created.
    virtual int_buffer_t GetIntBuffer();
    // Makes a copy of the buffer parameter val
    virtual void SetIntBuffer(int_buffer_t val);
  };

public:
  BAcel(Message* m);
  virtual ~BAcel(void);

  virtual oid_t Id();

  virtual bool SetId(oid_t id);

  virtual PAcel Property( string name );

};

