#pragma  once
#include <scene-core/sra-api/sra_scene.h>

using namespace sra;
typedef std::shared_ptr<IAcel> PAcel;

class ErrorAcel : public IAcel
{
public:
  virtual oid_t Id();
  virtual bool SetId(oid_t id);
  virtual IAcelList* List();

  virtual PAcel AddChild(oid_t id);
  virtual PAcel AddChild(oid_t id, pb::Acel* a);
  virtual bool DeleteChildId(oid_t id);
  virtual bool DeleteChild(size_t index);

  virtual PAcel Property( string name );
  virtual PAcel AddProperty(string name, oid_t id);
  virtual PAcel AddProperty(string name, oid_t id, pb::Acel* a);
  virtual bool DeleteProperty(string name);

  virtual IAcelValue* Value();
  virtual IAcelValue* SetValue();
  virtual void ClearValue();
  static ErrorAcel Instance;

};
class ErrorAcelValue: public IAcelValue
{
public:
  virtual float GetFloat();
  virtual void SetFloat(float val);
  virtual int32_t GetInt();
  virtual void SetInt(int32_t val);
  virtual string GetString();
  virtual void SetString(string val);
  virtual bool GetBool();
  virtual void SetBool(bool val);

  virtual float3_t GetFloat3();
  virtual void SetFloat3(sra::float3_t val);

  virtual byte_buffer_t GetByteBuffer();
  void SetByteBuffer(sra::byte_buffer_t val);

  virtual float_buffer_t GetFloatBuffer();
  virtual void SetFloatBuffer(sra::float_buffer_t val);

  virtual int_buffer_t GetIntBuffer();
  virtual void SetIntBuffer(sra::int_buffer_t val);

  static ErrorAcelValue Instance;
};
