#include "XAcelValue.h"

#include <scene-persistence/autogen/scenedb.pb.h>

//int32_t FieldAcelValue::GetInt()
//{
//  return message->GetReflection()->GetInt32(message, field);
//}

//sra::float_buffer_t FieldAcelValue::GetFloatBuffer()
//{
//  auto data = message->GetReflection()->GetRepeatedField<float>(message, field);
//
//  data.size()
//  float_buffer_t res(data.data(), data().
//  return res;
//}

float XAcelValue::GetFloat() 
{
	return value.has_float_value() ? value.float_value() : ErrorAcelValue::GetFloat();
}

void XAcelValue::SetFloat(float val)
{
  value.set_float_value(val);
  return;
}

int32_t XAcelValue::GetInt() 
{
  return value.has_int_value() ? value.int_value() : ErrorAcelValue::GetInt();
}

void XAcelValue::SetInt(int32_t val)
{
  value.set_int_value(val);
  return;
}

string XAcelValue::GetString() 
{
  return value.has_string_value() ? value.string_value() : ErrorAcelValue::GetString();
}

void XAcelValue::SetString(string val)
{
  value.set_string_value(val);
  return;
}

bool XAcelValue::GetBool() 
{
  return value.has_bool_value()? value.bool_value() : ErrorAcelValue::GetBool();
}

void XAcelValue::SetBool(bool val)
{
  value.set_bool_value(val);
  return;
}

sra::float3_t XAcelValue::GetFloat3() 
{
  if (!value.has_float_vec())
    return ErrorAcelValue::GetFloat3();
  auto val = value.float_vec();
  return float3_t(val.x(), val.y(), val.z());
}

void XAcelValue::SetFloat3(sra::float3_t val)
{
  auto vec = value.mutable_float_vec();
  vec->set_x(val.x);
  vec->set_y(val.y);
  vec->set_z(val.z);
  return;
}

sra::byte_buffer_t XAcelValue::GetByteBuffer() 
{
  if (!value.has_bytes_value_list())
    return ErrorAcelValue::GetByteBuffer();

  auto p = value.bytes_value_list();
   
  return byte_buffer_t(
    value.bytes_value_list().size(), (const uint8_t* ) p.c_str());
     
}

void XAcelValue::SetByteBuffer(sra::byte_buffer_t val)
{
  value.set_bytes_value_list((const char* ) val.Ptr(), val.Size());
  return;
}

sra::float_buffer_t XAcelValue::GetFloatBuffer() 
{
  return 
    value.float_value_list().size() == 0 ?
    ErrorAcelValue::GetFloatBuffer() :
    float_buffer_t(value.float_value_list().size(), value.float_value_list().data());
}

void XAcelValue::SetFloatBuffer(sra::float_buffer_t val)
{

  for(unsigned int i = 0; i < val.Size(); i++) {
    value.add_float_value_list(val.Ptr()[i]);
  }

  return;
}

sra::int_buffer_t XAcelValue::GetIntBuffer() 
{
  return 
    value.int_value_list().size() == 0 ?
    ErrorAcelValue::GetIntBuffer() :
    int_buffer_t(value.int_value_list().size(), value.int_value_list().data());
}

void XAcelValue::SetIntBuffer(sra::int_buffer_t val)
{

  for(unsigned int i = 0; i < val.Size(); i++) {
    value.add_int_value_list(val.Ptr()[i]);
  }

  return;
}

XAcelValue::XAcelValue(pb::AcelValue& v) : value(v)
{


}
