#pragma  once
#include <scene-core/sra-api/sra_scene.h>
#include "ErrorAcelValue.h"

namespace pb 
{
  class AcelValue;
}


// IAcelValue  implementation that wraps protobuf message
// arrays are not allowed to be empty (UnsupportedTypeError is thrown on access)

class XAcelValue: public ErrorAcelValue
{
  pb::AcelValue& value;
public:
  XAcelValue(pb::AcelValue& v);

  virtual float GetFloat();
  virtual void SetFloat(float val);
  virtual int32_t GetInt();
  virtual void SetInt(int32_t val);
  virtual string GetString();
  virtual void SetString(string val);
  virtual bool GetBool();
  virtual void SetBool(bool val);

  virtual float3_t GetFloat3() ;
  void SetFloat3(sra::float3_t val);

  // Const access to the buffer inside, no copy created.
  virtual byte_buffer_t GetByteBuffer();
  // Makes a copy of the buffer parameter val.
  void SetByteBuffer(sra::byte_buffer_t val);

  // Const access to the buffer inside, no copy created.
  virtual float_buffer_t GetFloatBuffer() ;
  // Makes a copy of the buffer parameter val.
  virtual void SetFloatBuffer(sra::float_buffer_t val);

  // Const access to the buffer inside, no copy created.
  virtual int_buffer_t GetIntBuffer();
  // Makes a copy of the buffer parameter val.
  virtual void SetIntBuffer(sra::int_buffer_t val);
};

