#pragma  once
#include <map>
#include "sra-api/sra_scene.h"

namespace pb
{
  class Scene;
}

/**
 * Acel globals has the id 1.
 */
class XScene : public sra::IScene
{
//PStream stream;  // TODO: necessary?
  std::shared_ptr<pb::Scene> scene;
  std::string work_dir;  // a path to the directory where scene file is (should be a root point for any other assets)

  // for named streams
  typedef std::map<std::string, size_t> names_map_t ;
  std::shared_ptr<names_map_t> named_streams;

  void InitializeNamedStreams();

public:
  XScene(std::shared_ptr<pb::Scene> scene, std::string workdir);
  virtual ~XScene() { }

  virtual size_t GetStreamCount();
  virtual PStream GetStream( size_t index );
  virtual PStream GetStream( std::string name ); // Named streams
  virtual PStream AddStream();
  virtual PStream AddStream( std::string name );
  virtual bool DeleteStream( size_t index );
  virtual bool DeleteStream( std::string name );
  virtual PAcel GetGlobals();
  virtual std::string GetRootDirectory();

  // not in IScene interface
  std::shared_ptr<pb::Scene> GetPBScene() { return scene; }
};
