from scenedb_pb2 import Scene;    
from surface_tracking_pb2 import VisionCamera;    
import random

def generate_id():
  # not unique, but collision is really unlikely until the number of generated ids exceeds ~ 2^32, and the birthday paradox comes into play
  return random.randint(1, 2**63)  

class SRAWriter:
  """hides basic writing operations on the sra protobuf file"""

  def __init__(self):
    self.sc = Scene()
    self.sc.globals.id = generate_id();

  def newid(self):
      return generate_id()

  def make_property(self, acel, name):
    prop = acel.properties.add()    
    prop.name = name    
    prop.value.id = generate_id() 
    return prop.value   

  def add_stream(self):
    return self.sc.streams.add()     

  def global_value(self, name):
    return self.make_property(self.sc.globals, name)

  def global_list(self, name):
    l =  self.make_property(self.sc.globals, name)
    l.children.extend([])
    return l

  def write_to_file(self, filename):
    f = open(filename, "wb")
    f.write(self.sc.SerializeToString())
    f.close()
    
  def get_scene(self):
	  return self.sc
       
