"""mapping between collada loader and sra protobuf structures"""

def convert_vector( a, b):
    c = b.astype(float)
    (a.x, a.y, a.z) = (c[0], c[1], c[2]) 

def convert_matrix( a, b):
    for row in b:
        a.extend([x for x in row.astype(float)])  

def convert_camera(cam, col_cam): 

    convert_vector(cam.position,col_cam.position)
    convert_vector(cam.up, col_cam.up)
    convert_vector(cam.direction, col_cam.direction)

    cam.zfar = col_cam.zfar
    cam.znear = col_cam.znear
    cam.aspect_ratio = col_cam.aspect_ratio
    cam.xfov = col_cam.xfov

def convert_spotlight(light, col_light):
    light.falloff_angle =col_light.falloff_ang
    convert_vector(light.position,col_light.position)
    convert_vector(light.up, col_light.up)
    convert_vector(light.direction, col_light.direction)
 

 
def convert_geometry(collada, sra):
    id = 0  
    for co in collada.objects:    
        geo = sra.add_geometry()
        geo.id = id
        id += 1    
        geo.vertices.extend(collada.vertex_atr[co])
        geo.normals.extend(collada.normal_atr[co])
        geo.texcoord.extend(collada.textur_atr[co])            
        geo.indices.extend(collada.vertex_idx[co])   
        if collada.diffuse_texture.has_key(co):
            fname = collada.diffuse_texture[co]
            assert(fname)
            tex_id = sra.find_or_create_texture(fname)
            geo.texture_id = tex_id

 