/*
 * sraimage.cpp
 *
 */

#include "backendMap.h"

int setMap(PAcel parent, string filename, IdManager::IdManager &idM, int id, mapType::type type) {

	PAcel image = parent->AddChild(id);						// the image Acel

	if(type < 38) { // all mesh types with enums < 38 are supported by ASSIMP
		setMapCImg(image, filename, type, idM);
	}
	//else if(type < ) {
	// other mesh types using other libraries ????
	//}
	else {
		cerr << "Unknown type.\n" << endl;
		return 0;
	}

	return id;
}

namespace backend {
CImg<unsigned char> *get_map(PAcel  map) {

	unsigned int w = map->Property("width")->Value()->GetInt();
	unsigned int h = map->Property("height")->Value()->GetInt();
	unsigned int d = map->Property("depth")->Value()->GetInt();
	unsigned int c = map->Property("channels")->Value()->GetInt();

	CImg<unsigned char> *myMap = new CImg<unsigned char>(w,h,d,c);

	for(unsigned int v=0; v<c; v++) {
		for(unsigned int z=0; z<d; z++) {
			for(unsigned int y=0; y<h; y++) {
				for(unsigned int x=0; x<w; x++) {
					unsigned int pos = v*w*h*d + w*h*z + w*y + x;
					myMap->atXY(y,x,z,v) = map->List()->Get(pos)->Value()->GetInt();
				}
			}
		}
	}

	return myMap;
}
}

void setMapCImg(PAcel image, string filename, mapType::type, IdManager::IdManager &idM) {
	CImg<unsigned char> imageIn(filename.c_str());
	PAcel w = image->AddProperty("width",idM.AllocateId());
	PAcel h = image->AddProperty("height",idM.AllocateId());
	PAcel d = image->AddProperty("depth",idM.AllocateId());
	PAcel c = image->AddProperty("channels",idM.AllocateId());
	w->SetValue()->SetInt(imageIn._width);
	h->SetValue()->SetInt(imageIn._height);
	d->SetValue()->SetInt(imageIn._depth);
	c->SetValue()->SetInt(imageIn._spectrum);
	for(unsigned int x=0; x<imageIn._width; x++) {
		for(unsigned int y=0; y<imageIn._height; y++) {
			for(unsigned int z=0; z<imageIn._depth; z++) {
				for(unsigned int v=0; v<imageIn._spectrum; v++) {
					int id = idM.AllocateId();
					PAcel pixel = image->AddChild(id);
					//unsigned int pos = x*y*z + y*z + z;
					cout << "pixel " << x << "," << y << " has id " << id << " and color " << static_cast<unsigned int>(imageIn(x,y,z,v)) << endl;
					pixel->SetValue()->SetInt(static_cast<unsigned int>(imageIn(x,y,z,v)));
				}
			}
		}
	}

}
