/*
 * protoMesh.h
 *
 *  Created on: Mar 14, 2014
 *      Author: christopher
 */

#ifndef PROTOMESH_H_
#define PROTOMESH_H_


#include <string>
#include <iostream>     // std::cout
#include <fstream>      // std::ifstream
#include <sstream>      // stringstream

// assimp include files, for open asset import library
#include <assimp/Importer.hpp> // C++ importer interface
#include <assimp/scene.h> // Output data structure
#include <assimp/postprocess.h> // Post processing flags

#include "../autogen/scenedb.pb.h"
#include "sraBackend.h"
#include "filetypes.h"
#include "../sra.h"

using namespace std;

int setMesh(PAcel parent, string filename, IdManager::IdManager &idM, meshType::type type, int **ids);

int setMeshAssimp(PAcel parent, IdManager::IdManager &idM, string filename, meshType::type type, int **ids);

namespace backend {
aiMesh *get_mesh(PAcel mesh);
}

#endif /* PROTOMESH_H_ */
