#pragma  once
#include <memory>
#include <iostream>
#include <fstream>
#include <string>

#include <scene-persistence/autogen/depth_stream.pb.h>
#include <google/protobuf/io/zero_copy_stream.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/io/zero_copy_stream.h>
#include <google/protobuf/io/zero_copy_stream_impl.h>


typedef Data DepthStream;

inline std::shared_ptr<DepthStream> GetDepthStream(string name)
{
  GOOGLE_PROTOBUF_VERIFY_VERSION;
  DepthStream *sc = new DepthStream();

  using namespace std;
  using namespace google::protobuf::io;

  fstream foo(name.c_str(), ios::in | ios::binary);
  if (!foo.is_open())
  {
    cerr << "depth stream missing :" << name << endl;
    throw std::runtime_error("depth stream missing");
  }
  ZeroCopyInputStream* input = new IstreamInputStream(&foo);
  CodedInputStream coded(input);
  coded.SetTotalBytesLimit(2000000000, 2000000000);
  if (!sc->ParseFromCodedStream(&coded)) {
    cerr << "Failed to parse scene." << endl;
    throw std::runtime_error("parsing scene failed");
  }
  delete input;
  return shared_ptr<DepthStream>(sc);
}