from  google.protobuf.descriptor_pb2 import *
from google.protobuf.text_format import *

class AcelValueType():
  def __init__(self, **kw):
    self.__dict__.update(kw)
class AcelType():
  def __init__(self, **kw):
    self.__dict__.update(kw)

class RendererSchemaParser(): 
  def __init__(self):
    pb = FileDescriptorSet()
    f = open("render.desc", "rb")
    self.data = pb.FromString(f.read())
    self.gen_typemap()

  def gen_typemap(self):
    f = FieldDescriptorProto
    self.rules = []
    def def_type(t, a, ft, **kw):
      def matcher(m):      
        #check base type first
        ok =  m.type == ft        
        #if check repeated
        ok = ok and ('rep' in kw   and m.label == f.LABEL_REPEATED or\
                     'rep' not in kw and m.label != f.LABEL_REPEATED )
        if 'msg' in kw:
          #print "message"
          #print m.type
 
          #print kw['msg']
          ok = ok and m.type_name == kw['msg']
          if ok:
            assert (m.label == f.LABEL_REQUIRED)
        return ok

      self.rules.append((matcher, t, a))
       
    def_type("float", "GetFloat", f.TYPE_FLOAT)
    def_type("int", "GetInt", f.TYPE_INT32)
    def_type("bool", "GetBool",   f.TYPE_BOOL)
    def_type("std::string", "GetString", f.TYPE_STRING)

    def_type("sra::float_buffer_t", "GetFloatBuffer", f.TYPE_FLOAT, rep=True)
    def_type("sra::int_buffer_t", "GetIntBuffer", f.TYPE_INT32, rep=True)
    def_type("sra::byte_buffer_t", "GetByteBuffer", f.TYPE_BYTES ) 

    def_type("glm::vec3", "GetFloat3", f.TYPE_MESSAGE,  msg=".ren.Vector")


  def typemap(self, field):
    for (match, ctype, acc) in self.rules:
      if match(field):
        return (ctype, acc)
    print field.type
    raise AssertionError("could not find any match for field %s " % field.name)

  def test(self):
    def proc_field(f):  
      print f.name
      print typemap(f) 

    def proc_msg(m):
      print m.name
      for f in m.field:
        proc_field(f)

    f = self.data.file[0]
    for x in f.message_type:
      proc_msg(x)

  def get_field_info(self, f):
    ctype, acc = self.typemap(f)
    return AcelValueType(name=f.name, type=ctype, accessor=acc)

  def get_type_fields(self, t):
    return AcelType(fields=[ self.get_field_info(x) for x in t.field], name=t.name)
  def get_types(self):
    return [self.get_type_fields(x) for x in self.data.file[0].message_type]
          


     










        
      