#ifndef FRAMES_TEXTURE_LOADER_H
#define FRAMES_TEXTURE_LOADER_H

#include "stdint.h"
#include <string>
#include "texture_loader_api.h"

namespace cv
{
	class Mat;
}

// reads a sequence of frames (png) using opencv library
class FramesTextureLoader : public ITextureLoader
{
	private:

		std::string frames_name;
		cv::Mat    *frame;
		int   first_frame;
		int    last_frame;
		int frame_step;

		void Initialize();

	public:

		/* We expect a filename with the following printf format
		 * [path/prefix]%0nd[posfix].png
		 *
		 * Fields in [] are optional. Nor the path/prefix neither
		 * postfix may have a '%' character. */
		FramesTextureLoader(std::string file, int first_frame = -1, 
				int last_frame = -1, int frame_step = -1); 
		FramesTextureLoader(pb::Stream& s, std::string work_dir); 

		virtual ~FramesTextureLoader();

		virtual bool NextFrame();
		virtual void SetCurrentData(const uint8_t* data, int w=-1, int h=-1, int c=-1, int d=-1);
};

#endif

