#ifndef VIDEO_TEXTURE_LOADER_H
#define VIDEO_TEXTURE_LOADER_H

#include "stdint.h"
#include "avbin.h"
#include <string>
#include "texture_loader_api.h"

// reads a video file using avbin library
class VideoTextureLoader : public ITextureLoader
{
	private:

		AVbinStream* video_stream;
		AVbinFile* file ;
		int video_stream_index;
		void Load(std::string file);

	public:

		VideoTextureLoader(std::string file); 
		VideoTextureLoader(pb::Stream & s, std::string work_dir); 

		virtual bool NextFrame();
		virtual void SetCurrentData(const uint8_t* data, int w=-1, int h=-1, int c=-1, int d=-1){};
		virtual ~VideoTextureLoader();
};

#endif

