#include <memory>
#include <iostream>
#include <fstream>
#include <string>
#include <cmath>
#include <vector>

#include <scene-core/sra-api/sra_scene.h>
#include <scene-core/sra_implementation.h>
#include <scene-core/ErrorAcelValue.h>
#include <scene-core/XAcelValue.h>
#include "accessors.h"

namespace sra { class IScene; class IAcel; }
using namespace std;

void PrintMesh(ostream &s, TCMeshAcelAccessor &m) {

	s << m.vertex_ids().Size() << endl;
	for(int v = 0; v < m.vertex_ids().Size(); v++) {
		s << m.vertex_ids().Ptr()[v] << " "
		  << m.vertex_positions().Ptr()[3*v] << " "
		  << m.vertex_positions().Ptr()[3*v + 1] << " "
		  << m.vertex_positions().Ptr()[3*v + 2] << endl;
	}
	s << m.faces().Size()/3 << endl;
	for(int f = 0; f < (m.faces().Size()/3); f++) {
		for(int i = 0; i < 3; i++) 	s << m.faces().Ptr()[3*f + i] << " ";
		s << endl;
	}
	cout << endl;

	return;
}

/********************************************************************************************/

int main(int argc, char **argv) {

	std::shared_ptr<sra::IScene> sc = sra::get_scene_representation(argv[1]);

	PAcel meshes = sc->GetGlobals()->Property("meshes");

	for(int i = 0; i < meshes->List()->Count(); i++) {
		PAcel m = meshes->List()->Get(i);
		TCMeshAcelAccessor mesh(m);
		cout << "-- Frame "<< mesh.frame() << endl;
		PrintMesh(cout, mesh);
	}

	return 0;
}

